/*
 * This source file was generated by FireStorm/DAO.
 * 
 * If you purchase a full license for FireStorm/DAO you can customize this header file.
 * 
 * For more information please visit http://www.codefutures.com/products/firestorm
 */

package umgnotas.eis.jdbc;

import umgnotas.eis.dao.*;
import umgnotas.eis.factory.*;
import java.util.Date;
import umgnotas.eis.dto.*;
import umgnotas.eis.exceptions.*;
import java.sql.Connection;
import java.util.Collection;
import java.sql.PreparedStatement;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Time;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;

public class TbPagosDaoImpl extends AbstractDAO implements TbPagosDao
{
	/** 
	 * The factory class for this DAO has two versions of the create() method - one that
takes no arguments and one that takes a Connection argument. If the Connection version
is chosen then the connection will be stored in this attribute and will be used by all
calls to this DAO, otherwise a new Connection will be allocated for each operation.
	 */
	protected java.sql.Connection userConn;

	/** 
	 * All finder methods in this class use this SELECT constant to build their queries
	 */
	protected final String SQL_SELECT = "SELECT det_correlativo, det_fecha_pago, det_saldo, det_pagado, det_estado, det_trx_codigo, det_asi_codigo FROM " + getTableName() + "";

	/** 
	 * Finder methods will pass this value to the JDBC setMaxRows method
	 */
	protected int maxRows;

	/** 
	 * SQL INSERT statement for this table
	 */
	protected final String SQL_INSERT = "INSERT INTO " + getTableName() + " ( det_correlativo, det_fecha_pago, det_saldo, det_pagado, det_estado, det_trx_codigo, det_asi_codigo ) VALUES ( ?, ?, ?, ?, ?, ?, ? )";

	/** 
	 * SQL UPDATE statement for this table
	 */
	protected final String SQL_UPDATE = "UPDATE " + getTableName() + " SET det_correlativo = ?, det_fecha_pago = ?, det_saldo = ?, det_pagado = ?, det_estado = ?, det_trx_codigo = ?, det_asi_codigo = ? WHERE det_correlativo = ?";

	/** 
	 * SQL DELETE statement for this table
	 */
	protected final String SQL_DELETE = "DELETE FROM " + getTableName() + " WHERE det_correlativo = ?";

	/** 
	 * Index of column det_correlativo
	 */
	protected static final int COLUMN_DET_CORRELATIVO = 1;

	/** 
	 * Index of column det_fecha_pago
	 */
	protected static final int COLUMN_DET_FECHA_PAGO = 2;

	/** 
	 * Index of column det_saldo
	 */
	protected static final int COLUMN_DET_SALDO = 3;

	/** 
	 * Index of column det_pagado
	 */
	protected static final int COLUMN_DET_PAGADO = 4;

	/** 
	 * Index of column det_estado
	 */
	protected static final int COLUMN_DET_ESTADO = 5;

	/** 
	 * Index of column det_trx_codigo
	 */
	protected static final int COLUMN_DET_TRX_CODIGO = 6;

	/** 
	 * Index of column det_asi_codigo
	 */
	protected static final int COLUMN_DET_ASI_CODIGO = 7;

	/** 
	 * Number of columns
	 */
	protected static final int NUMBER_OF_COLUMNS = 7;

	/** 
	 * Index of primary-key column det_correlativo
	 */
	protected static final int PK_COLUMN_DET_CORRELATIVO = 1;

	/** 
	 * Inserts a new row in the tb_pagos table.
	 */
	public TbPagosPk insert(TbPagos dto) throws TbPagosDaoException
	{
		long t1 = System.currentTimeMillis();
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		ResultSet rs = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			stmt = conn.prepareStatement( SQL_INSERT );
			int index = 1;
			if (dto.getDetCorrelativo() != null) {
				stmt.setInt( index++, dto.getDetCorrelativo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			stmt.setDate(index++, dto.getDetFechaPago()==null ? null : new java.sql.Date( dto.getDetFechaPago().getTime() ) );
			if (dto.getDetSaldo() != null) {
				stmt.setFloat( index++, dto.getDetSaldo().floatValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.FLOAT);
			}
		
			if (dto.getDetPagado() != null) {
				stmt.setFloat( index++, dto.getDetPagado().floatValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.FLOAT);
			}
		
			stmt.setString( index++, dto.getDetEstado() );
			if (dto.getDetTrxCodigo() != null) {
				stmt.setInt( index++, dto.getDetTrxCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			if (dto.getDetAsiCodigo() != null) {
				stmt.setInt( index++, dto.getDetAsiCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			System.out.println( "Executing " + SQL_INSERT + " with DTO: " + dto );
			int rows = stmt.executeUpdate();
			long t2 = System.currentTimeMillis();
			System.out.println( rows + " rows affected (" + (t2-t1) + " ms)" );
			reset(dto);
			return dto.createPk();
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbPagosDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Updates a single row in the tb_pagos table.
	 */
	public void update(TbPagosPk pk, TbPagos dto) throws TbPagosDaoException
	{
		long t1 = System.currentTimeMillis();
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			System.out.println( "Executing " + SQL_UPDATE + " with DTO: " + dto );
			stmt = conn.prepareStatement( SQL_UPDATE );
			int index=1;
			if (dto.getDetCorrelativo() != null) {
				stmt.setInt( index++, dto.getDetCorrelativo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			stmt.setDate(index++, dto.getDetFechaPago()==null ? null : new java.sql.Date( dto.getDetFechaPago().getTime() ) );
			if (dto.getDetSaldo() != null) {
				stmt.setFloat( index++, dto.getDetSaldo().floatValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.FLOAT);
			}
		
			if (dto.getDetPagado() != null) {
				stmt.setFloat( index++, dto.getDetPagado().floatValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.FLOAT);
			}
		
			stmt.setString( index++, dto.getDetEstado() );
			if (dto.getDetTrxCodigo() != null) {
				stmt.setInt( index++, dto.getDetTrxCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			if (dto.getDetAsiCodigo() != null) {
				stmt.setInt( index++, dto.getDetAsiCodigo().intValue() );
			} else {
				stmt.setNull(index++, java.sql.Types.INTEGER);
			}
		
			if (pk.getDetCorrelativo() != null) {
				stmt.setInt( 8, pk.getDetCorrelativo().intValue() );
			} else {
				stmt.setNull(8, java.sql.Types.INTEGER);
			}
		
			int rows = stmt.executeUpdate();
			reset(dto);
			long t2 = System.currentTimeMillis();
			System.out.println( rows + " rows affected (" + (t2-t1) + " ms)" );
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbPagosDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Deletes a single row in the tb_pagos table.
	 */
	public void delete(TbPagosPk pk) throws TbPagosDaoException
	{
		long t1 = System.currentTimeMillis();
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			System.out.println( "Executing " + SQL_DELETE + " with PK: " + pk );
			stmt = conn.prepareStatement( SQL_DELETE );
			if (pk.getDetCorrelativo() != null) {
				stmt.setInt( 1, pk.getDetCorrelativo().intValue() );
			} else {
				stmt.setNull(1, java.sql.Types.INTEGER);
			}
		
			int rows = stmt.executeUpdate();
			long t2 = System.currentTimeMillis();
			System.out.println( rows + " rows affected (" + (t2-t1) + " ms)" );
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbPagosDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Returns the rows from the tb_pagos table that matches the specified primary-key value.
	 */
	public TbPagos findByPrimaryKey(TbPagosPk pk) throws TbPagosDaoException
	{
		return findByPrimaryKey( pk.getDetCorrelativo() );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_correlativo = :detCorrelativo'.
	 */
	public TbPagos findByPrimaryKey(Integer detCorrelativo) throws TbPagosDaoException
	{
		TbPagos ret[] = findByDynamicSelect( SQL_SELECT + " WHERE det_correlativo = ?", new Object[] { detCorrelativo } );
		return ret.length==0 ? null : ret[0];
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria ''.
	 */
	public TbPagos[] findAll() throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT, null );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_asi_codigo = :detAsiCodigo'.
	 */
	public TbPagos[] findByTbAsignacion(int detAsiCodigo) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_asi_codigo = ?", new Object[] {  new Integer(detAsiCodigo) } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_trx_codigo = :detTrxCodigo'.
	 */
	public TbPagos[] findByTbTransaccion(int detTrxCodigo) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_trx_codigo = ?", new Object[] {  new Integer(detTrxCodigo) } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_correlativo = :detCorrelativo'.
	 */
	public TbPagos[] findWhereDetCorrelativoEquals(int detCorrelativo) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_correlativo = ? ORDER BY det_correlativo", new Object[] {  new Integer(detCorrelativo) } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_fecha_pago = :detFechaPago'.
	 */
	public TbPagos[] findWhereDetFechaPagoEquals(String detFechaPago) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_fecha_pago = ? ORDER BY det_fecha_pago", new Object[] { detFechaPago } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_saldo = :detSaldo'.
	 */
	public TbPagos[] findWhereDetSaldoEquals(String detSaldo) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_saldo = ? ORDER BY det_saldo", new Object[] { detSaldo } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_pagado = :detPagado'.
	 */
	public TbPagos[] findWhereDetPagadoEquals(String detPagado) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_pagado = ? ORDER BY det_pagado", new Object[] { detPagado } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_estado = :detEstado'.
	 */
	public TbPagos[] findWhereDetEstadoEquals(String detEstado) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_estado = ? ORDER BY det_estado", new Object[] { detEstado } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_trx_codigo = :detTrxCodigo'.
	 */
	public TbPagos[] findWhereDetTrxCodigoEquals(int detTrxCodigo) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_trx_codigo = ? ORDER BY det_trx_codigo", new Object[] {  new Integer(detTrxCodigo) } );
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the criteria 'det_asi_codigo = :detAsiCodigo'.
	 */
	public TbPagos[] findWhereDetAsiCodigoEquals(int detAsiCodigo) throws TbPagosDaoException
	{
		return findByDynamicSelect( SQL_SELECT + " WHERE det_asi_codigo = ? ORDER BY det_asi_codigo", new Object[] {  new Integer(detAsiCodigo) } );
	}

	/**
	 * Method 'TbPagosDaoImpl'
	 * 
	 */
	public TbPagosDaoImpl()
	{
	}

	/**
	 * Method 'TbPagosDaoImpl'
	 * 
	 * @param userConn
	 */
	public TbPagosDaoImpl(final java.sql.Connection userConn)
	{
		this.userConn = userConn;
	}

	/** 
	 * Sets the value of maxRows
	 */
	public void setMaxRows(int maxRows)
	{
		this.maxRows = maxRows;
	}

	/** 
	 * Gets the value of maxRows
	 */
	public int getMaxRows()
	{
		return maxRows;
	}

	/**
	 * Method 'getTableName'
	 * 
	 * @return String
	 */
	public String getTableName()
	{
		return "tb_pagos";
	}

	/** 
	 * Fetches a single row from the result set
	 */
	protected TbPagos fetchSingleResult(ResultSet rs) throws SQLException
	{
		if (rs.next()) {
			TbPagos dto = new TbPagos();
			populateDto( dto, rs);
			return dto;
		} else {
			return null;
		}
		
	}

	/** 
	 * Fetches multiple rows from the result set
	 */
	protected TbPagos[] fetchMultiResults(ResultSet rs) throws SQLException
	{
		Collection resultList = new ArrayList();
		while (rs.next()) {
			TbPagos dto = new TbPagos();
			populateDto( dto, rs);
			resultList.add( dto );
		}
		
		TbPagos ret[] = new TbPagos[ resultList.size() ];
		resultList.toArray( ret );
		return ret;
	}

	/** 
	 * Populates a DTO with data from a ResultSet
	 */
	protected void populateDto(TbPagos dto, ResultSet rs) throws SQLException
	{
		dto.setDetCorrelativo( new Integer( rs.getInt(COLUMN_DET_CORRELATIVO) ) );
		dto.setDetFechaPago( rs.getDate(COLUMN_DET_FECHA_PAGO ) );
		dto.setDetSaldo( new Float( rs.getFloat(COLUMN_DET_SALDO) ) );
		dto.setDetPagado( new Float( rs.getFloat(COLUMN_DET_PAGADO) ) );
		dto.setDetEstado( rs.getString( COLUMN_DET_ESTADO ) );
		dto.setDetTrxCodigo( new Integer( rs.getInt(COLUMN_DET_TRX_CODIGO) ) );
		if (rs.wasNull()) {
			dto.setDetTrxCodigo( null );
		}
		
		dto.setDetAsiCodigo( new Integer( rs.getInt(COLUMN_DET_ASI_CODIGO) ) );
	}

	/** 
	 * Resets the modified attributes in the DTO
	 */
	protected void reset(TbPagos dto)
	{
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the specified arbitrary SQL statement
	 */
	public TbPagos[] findByDynamicSelect(String sql, Object[] sqlParams) throws TbPagosDaoException
	{
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		ResultSet rs = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			// construct the SQL statement
			final String SQL = sql;
		
		
			System.out.println( "Executing " + SQL );
			// prepare statement
			stmt = conn.prepareStatement( SQL );
			stmt.setMaxRows( maxRows );
		
			// bind parameters
			for (int i=0; sqlParams!=null && i<sqlParams.length; i++ ) {
				stmt.setObject( i+1, sqlParams[i] );
			}
		
		
			rs = stmt.executeQuery();
		
			// fetch the results
			return fetchMultiResults(rs);
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbPagosDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(rs);
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	/** 
	 * Returns all rows from the tb_pagos table that match the specified arbitrary SQL statement
	 */
	public TbPagos[] findByDynamicWhere(String sql, Object[] sqlParams) throws TbPagosDaoException
	{
		// declare variables
		final boolean isConnSupplied = (userConn != null);
		Connection conn = null;
		PreparedStatement stmt = null;
		ResultSet rs = null;
		
		try {
			// get the user-specified connection or get a connection from the ResourceManager
			conn = isConnSupplied ? userConn : ResourceManager.getConnection();
		
			// construct the SQL statement
			final String SQL = SQL_SELECT + " WHERE " + sql;
		
		
			System.out.println( "Executing " + SQL );
			// prepare statement
			stmt = conn.prepareStatement( SQL );
			stmt.setMaxRows( maxRows );
		
			// bind parameters
			for (int i=0; sqlParams!=null && i<sqlParams.length; i++ ) {
				stmt.setObject( i+1, sqlParams[i] );
			}
		
		
			rs = stmt.executeQuery();
		
			// fetch the results
			return fetchMultiResults(rs);
		}
		catch (Exception _e) {
			_e.printStackTrace();
			throw new TbPagosDaoException( "Exception: " + _e.getMessage(), _e );
		}
		finally {
			ResourceManager.close(rs);
			ResourceManager.close(stmt);
			if (!isConnSupplied) {
				ResourceManager.close(conn);
			}
		
		}
		
	}

	@Override
	public Connection getUserConn() {
		return this.userConn;
	}

	@Override
	public void setUserConn(Connection userConn) {
		this.userConn = userConn;
	}


}
